﻿using System.Collections.Generic;

using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Controls;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.checkedComboBoxEdit.Properties.ValueMember   = "Name";
            this.checkedComboBoxEdit.Properties.DisplayMember = "Name";

            this.checkedComboBoxEdit.Properties.DataSource = Employee.GetList();

            this.checkedComboBoxEdit.GetItemEnabled += checkedComboBoxEdit_GetItemEnabled;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 체크 콤보 박스 에디터 항목 이용 가능 여부 구하기 - checkedComboBoxEdit_GetItemEnabled(sender, e)

        /// <summary>
        /// 체크 콤보 박스 에디터 항목 이용 가능 여부 구하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void checkedComboBoxEdit_GetItemEnabled(object sender, GetCheckedComboBoxItemEnabledEventArgs e)
        {
            if(e.ListSourceRowIndex == -1)
            {
                return;
            }

            CheckedComboBoxEdit checkedComboBoxEdit = sender as CheckedComboBoxEdit;

            List<Employee> list = checkedComboBoxEdit.Properties.DataSource as List<Employee>;

            bool hired = list[e.ListSourceRowIndex].Hired;

            e.Enabled = !hired;
        }

        #endregion
    }
}